<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "medication".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Medication".
 *
 * Columns in table "medication" available as properties of the model,
 * followed by relations of table "medication" available as properties of the model.
 *
 * @property integer $id
 * @property string $name
 * @property string $ndc
 * @property string $nonpropietary_name
 * @property string $description
 * @property string $ingredients
 * @property string $pharmaceutical_class
 *
 * @property MedicationManufacturer[] $medicationManufacturers
 * @property SpecialtyMedication[] $specialtyMedications
 */
abstract class BaseMedication extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'medication';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Medication|Medications', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('name', 'required'),
            array('name', 'length', 'max' => 120),
            array('ndc', 'length', 'max' => 10),
            array('nonpropietary_name, description, ingredients, pharmaceutical_class', 'safe'),
            array('ndc, nonpropietary_name, description, ingredients, pharmaceutical_class', 'default',
                'setOnEmpty' => true, 'value' => null),
            array('id, name, ndc, nonpropietary_name, description, ingredients, pharmaceutical_class',
                'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'medicationManufacturers' => array(self::HAS_MANY, 'MedicationManufacturer', 'medication_id'),
            'specialtyMedications' => array(self::HAS_MANY, 'SpecialtyMedication', 'medication_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'ndc' => Yii::t('app', 'Ndc'),
            'nonpropietary_name' => Yii::t('app', 'Nonpropietary Name'),
            'description' => Yii::t('app', 'Description'),
            'ingredients' => Yii::t('app', 'Ingredients'),
            'pharmaceutical_class' => Yii::t('app', 'Pharmaceutical Class'),
            'medicationManufacturers' => null,
            'specialtyMedications' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('ndc', $this->ndc, true);
        $criteria->compare('nonpropietary_name', $this->nonpropietary_name, true);
        $criteria->compare('description', $this->description, true);
        $criteria->compare('ingredients', $this->ingredients, true);
        $criteria->compare('pharmaceutical_class', $this->pharmaceutical_class, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
